VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form MapColorForm 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "MapColor"
   ClientHeight    =   6405
   ClientLeft      =   2715
   ClientTop       =   1845
   ClientWidth     =   7830
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6405
   ScaleWidth      =   7830
   Begin VB.PictureBox picMap 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      FillStyle       =   0  'Solid
      ForeColor       =   &H00000000&
      Height          =   4455
      Left            =   0
      Picture         =   "MapColor.frx":0000
      ScaleHeight     =   295
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   327
      TabIndex        =   0
      Top             =   0
      Width           =   4935
   End
   Begin MSComDlg.CommonDialog FileDialog 
      Left            =   1920
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Select Map File"
      Filter          =   "Map Files (*.map)|*.map|All files (*.*)|*.*"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuColor 
      Caption         =   "&Color"
      Begin VB.Menu mnuColor2 
         Caption         =   "&2 Color"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuColor3Exhaustively 
         Caption         =   "3 Color Exhaustively"
         Shortcut        =   ^{F3}
      End
      Begin VB.Menu mnuColor3 
         Caption         =   "&3 Color"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuColor4Exhaustively 
         Caption         =   "4 Color Exhaustively"
         Shortcut        =   ^{F4}
      End
      Begin VB.Menu mnuColor4 
         Caption         =   "&4 Color"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuColor5 
         Caption         =   "&5 Color"
         Shortcut        =   {F5}
      End
   End
   Begin VB.Menu mnuDebug 
      Caption         =   "&Debugging"
      Begin VB.Menu mnuDebugNumbers 
         Caption         =   "Show Region Numbers"
      End
      Begin VB.Menu mnuDebugCounts 
         Caption         =   "Show Neighbor Counts"
      End
      Begin VB.Menu mnuDebugLists 
         Caption         =   "Print Neighbor Lists"
      End
   End
End
Attribute VB_Name = "MapColorForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Map 5-coloring program.
Option Explicit

Private DrawingRegion As MapRegion

Private Regions As Collection
Private CurX As Single
Private CurY As Single
Private LastX As Single
Private LastY As Single

Private NeedNeighbors As Boolean
' Remove all menu checkmarks.
Private Sub ClearMenuChecks()
Dim ctl As Control

    For Each ctl In Controls
        If TypeOf ctl Is Menu Then ctl.Checked = False
    Next ctl
End Sub

' Reset all of the region colors.
Private Sub ResetColors()
Dim rgn As MapRegion

    For Each rgn In Regions
        rgn.Color = UNCOLORED
    Next rgn
End Sub

' 2-color the map.
Private Sub mnuColor2_Click()
Dim rgn As MapRegion

    ClearMenuChecks
    mnuColor2.Checked = True
    MousePointer = vbHourglass
    DoEvents

    ' Assign the colors.
    If AssignColors2() Then
        MsgBox "This map is not 2-colorable.", _
            vbOKOnly Or vbExclamation, _
            "Not 2-Colorable"
    Else
        VerifyColoring 1
    End If

    Redraw
    MousePointer = vbDefault
End Sub

' 3-color the map.
Private Sub mnuColor3_Click()
Dim rgn As MapRegion

    ClearMenuChecks
    mnuColor3.Checked = True
    MousePointer = vbHourglass
    DoEvents

    ' Assign the colors.
    If AssignColors3() Then
        MsgBox "This map is not 3-colorable.", _
            vbOKOnly Or vbExclamation, _
            "Not 3-Colorable"
    Else
        VerifyColoring 2
    End If

    Redraw
    MousePointer = vbDefault
End Sub

' 3-color the map exhaustively.
Private Sub mnuColor3Exhaustively_Click()
Dim rgn As MapRegion

    ClearMenuChecks
    mnuColor3Exhaustively.Checked = True
    MousePointer = vbHourglass
    DoEvents

    ' Assign the colors.
    If AssignColors3Exhaustively() Then
        MsgBox "This map is not 3-colorable.", _
            vbOKOnly Or vbExclamation, _
            "Not 3-Colorable"
    Else
        VerifyColoring 2
    End If

    Redraw
    MousePointer = vbDefault
End Sub

' 4-color the map.
Private Sub mnuColor4_Click()
Dim rgn As MapRegion

    ClearMenuChecks
    mnuColor4.Checked = True
    MousePointer = vbHourglass
    DoEvents

    ' Assign the colors.
    If AssignColors4() Then
        MsgBox "This map is not 4-colorable.", _
            vbOKOnly Or vbExclamation, _
            "Not 4-Colorable"
    Else
        VerifyColoring 3
    End If

    Redraw
    MousePointer = vbDefault
End Sub


' 4-color the map exhaustively.
Private Sub mnuColor4Exhaustively_Click()
Dim rgn As MapRegion

    ClearMenuChecks
    mnuColor4Exhaustively.Checked = True
    MousePointer = vbHourglass
    DoEvents

    ' Assign the colors.
    If AssignColors4Exhaustively() Then
        MsgBox "This map is not 4-colorable.", _
            vbOKOnly Or vbExclamation, _
            "Not 4-Colorable"
    Else
        VerifyColoring 3
    End If

    Redraw
    MousePointer = vbDefault
End Sub
' Show the region numbers.
Private Sub mnuDebugNumbers_Click()
    mnuDebugNumbers.Checked = Not mnuDebugNumbers.Checked
    mnuDebugCounts.Checked = False
    Redraw
End Sub
' Show the neighbor counts.
Private Sub mnuDebugCounts_Click()
    mnuDebugCounts.Checked = Not mnuDebugCounts.Checked
    mnuDebugNumbers.Checked = False
    Redraw
End Sub

' 5-color the map.
Private Sub xAssignColors5()
Dim all_regions As New Collection
Dim rgn As MapRegion
Dim n1 As MapRegion
Dim n2 As MapRegion
Dim stack As New Collection
Dim obj As Object
Dim color_used(0 To 4) As Boolean
Dim i As Integer

    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Make the regions copy their neighbor lists.
    For Each rgn In Regions
        rgn.SaveNeighbors
    Next rgn
    
    ' Save a copy of the region list.
    For Each rgn In Regions
        all_regions.Add rgn
    Next rgn

    ' Push regions onto the stack.
    Do While Regions.count > 0
        ' Look for regions with degree < 5.
        For Each rgn In Regions
            If rgn.Neighbors.count < 5 _
                Then Exit For
        Next rgn
        
        ' If we did not find one, look for a
        ' node with degree 5 with two mutually
        ' non-adjacent children of degree <= 7.
        If rgn Is Nothing Then
            For Each rgn In Regions
                If rgn.FindNonAdjacents(n1, n2) _
                    Then Exit For
            Next rgn
            
            ' If we still did not find one, there's
            ' something wrong.
            If rgn Is Nothing Then
                MsgBox "Error finding node to remove."
                Exit Do
            End If
            
            ' Push rgn and its adjacency list
            ' onto the stack.
            stack.Add rgn
            stack.Add rgn.Neighbors
            
            ' Remove the node from the graph.
            rgn.RemoveFromGraph
            Regions.Remove Format$(rgn.Number)
            
            ' Associate n1 and n2.
            n1.AssociateWith n2
            
            ' Push n1 and n2 onto the stack.
            stack.Add n1
            stack.Add n2

            ' Remove n1 from the graph.
            n1.RemoveFromGraph
            Regions.Remove Format$(n1.Number)
        Else
            ' Push rgn and its adjacency list
            ' onto the stack.
            stack.Add rgn
            stack.Add rgn.Neighbors
            
            ' Remove the node from the graph.
            rgn.RemoveFromGraph
            Regions.Remove Format$(rgn.Number)
        End If
    Loop
    
    ' Pop regions off the stack and color them.
    Do While stack.count > 0
        Set obj = stack(stack.count)
        stack.Remove stack.count
        Set rgn = stack(stack.count)
        stack.Remove stack.count
        
        If TypeOf obj Is Collection Then
            For i = 0 To 4
                color_used(i) = False
            Next i
            ' Assign rgn a color different from
            ' those used by its neighbors.
            For Each n1 In obj
                color_used(n1.Color) = True
            Next n1

            ' See what color is left.
            For i = 0 To 4
                If Not color_used(i) Then Exit For
            Next i

            ' If we did not find a usable color,
            ' there's something wrong.
            If i > 4 Then
                MsgBox "Error finding color for node."
            Else
                rgn.Color = i
            End If
        Else
            ' Assign rgn the same color as its
            ' associated node.
            rgn.Color = obj.Color
        End If
    Loop

    ' Restore the region list.
    For Each rgn In all_regions
        Regions.Add rgn, Format$(rgn.Number)
    Next rgn

    ' Restore the saved neighbor lists.
    For Each rgn In Regions
        rgn.RestoreNeighbors
    Next rgn
End Sub
' 5-color the map.
Private Sub AssignColors5()
Dim num_low_degree As Integer
Dim num_non_adjacent As Integer
Dim all_regions As New Collection
Dim rgn As MapRegion
Dim n1 As MapRegion
Dim n2 As MapRegion
Dim stack As New Collection
Dim obj As Object
Dim color_used(0 To 4) As Boolean
Dim i As Integer

    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Make the regions save their neighbor lists.
    For Each rgn In Regions
        rgn.SaveNeighbors
    Next rgn

    ' Save a copy of the region list.
    For Each rgn In Regions
        all_regions.Add rgn
    Next rgn

    ' Push regions onto the stack.
    num_low_degree = 0
    num_non_adjacent = 0
    Do While Regions.count > 0
        ' Look for regions with degree < 5.
        For Each rgn In Regions
            If rgn.Neighbors.count < 5 _
                Then Exit For
        Next rgn

        ' If we did not find one, look for a
        ' node with degree 5 with two mutually
        ' non-adjacent children of degree <= 7.
        If rgn Is Nothing Then
            num_non_adjacent = num_non_adjacent + 1
            For Each rgn In Regions
                If rgn.FindNonAdjacents(n1, n2) _
                    Then Exit For
            Next rgn

            ' If we still did not find one, there's
            ' something wrong.
            If rgn Is Nothing Then
                MsgBox "Error finding node to remove."
                Exit Do
            End If

            ' Push rgn and its adjacency list
            ' onto the stack.
            stack.Add rgn
            stack.Add rgn.Neighbors

            ' Remove the node from the graph.
            rgn.RemoveFromGraph
            Regions.Remove Format$(rgn.Number)

            ' Associate n1 and n2.
            n1.AssociateWith n2

            ' Push n1 and n2 onto the stack.
            stack.Add n1
            stack.Add n2

            ' Remove n1 from the graph.
            n1.RemoveFromGraph
            Regions.Remove Format$(n1.Number)
        Else
            num_low_degree = num_low_degree + 1

            ' Push rgn and its adjacency list
            ' onto the stack.
            stack.Add rgn
            stack.Add rgn.Neighbors

            ' Remove the node from the graph.
            rgn.RemoveFromGraph
            Regions.Remove Format$(rgn.Number)
        End If
    Loop

    Debug.Print "# low degree:   " & num_low_degree
    Debug.Print "# non-adjacent: " & num_non_adjacent

    ' Pop regions off the stack and color them.
    Do While stack.count > 0
        Set obj = stack(stack.count)
        stack.Remove stack.count
        Set rgn = stack(stack.count)
        stack.Remove stack.count

        If TypeOf obj Is Collection Then
            ' Restore the region to the map.
            Regions.Add rgn, Format$(rgn.Number)
            Set rgn.Neighbors = obj

            ' Assign rgn a color different from
            ' those used by its neighbors.
            rgn.PickUnusedColor
        Else
            ' Assign rgn the same color as its
            ' associated node.
            rgn.Color = obj.Color
        End If
    Loop

    ' Restore the region list to its original order.
    Set Regions = New Collection
    For Each rgn In all_regions
        Regions.Add rgn, Format$(rgn.Number)
        rgn.RestoreNeighbors
    Next rgn
End Sub

' 2-color the map.
' Return True if the map is not 2-colorable.
Private Function AssignColors2() As Boolean
Dim rgn As MapRegion

    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Assume we will fail.
    AssignColors2 = True

    ' Color starting from each region to ensure
    ' that all disconnected areas are colored.
    For Each rgn In Regions
        ' See if this region has a color yet.
        If rgn.Color = UNCOLORED Then
            ' Assign a color.
            If rgn.Assign2Color(0) Then Exit Function
        End If
    Next rgn

    ' We succeeded.
    AssignColors2 = False
End Function
' 3-color the map exhaustively.
Private Function AssignColors3Exhaustively() As Boolean
    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Color the map.
    AssignColors3Exhaustively = ExhaustivelyColor(2)
End Function
' 3-color the map.
Private Function AssignColors3() As Boolean
Dim all_regions As New Collection
Dim rgn As MapRegion
Dim stack As New Collection

    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Make the regions copy their neighbor lists.
    For Each rgn In Regions
        rgn.SaveNeighbors
    Next rgn

    ' Save a copy of the region list.
    For Each rgn In Regions
        all_regions.Add rgn
    Next rgn

    ' Push regions onto the stack.
    Do While Regions.count > 0
        ' Look for a region with degree < 3.
        For Each rgn In Regions
            If rgn.Neighbors.count < 3 _
                Then Exit For
        Next rgn

        ' See if we found one.
        If rgn Is Nothing Then
            ' There are no more with degree < 3.
            Exit Do
        Else
            ' Push rgn onto the stack.
            stack.Add rgn

            ' Remove the node from the graph.
            rgn.RemoveFromGraph
            Regions.Remove Format$(rgn.Number)
        End If
    Loop
    Debug.Print "Map simplified from " & _
        all_regions.count & " to " & _
        Regions.count & " regions."

    ' Exhaustively color the rest of the map.
    AssignColors3 = ExhaustivelyColor(2)

    ' Pop regions off the stack and color them.
    Do While stack.count > 0
        ' Get the region.
        Set rgn = stack(stack.count)
        stack.Remove stack.count

        ' Restore the region to the map.
        Regions.Add rgn, Format$(rgn.Number)
        rgn.RestoreNeighbors

        ' Assign rgn a color different from
        ' those used by its neighbors.
        rgn.PickUnusedColor
    Loop

    ' Restore the region list to its original order.
    Set Regions = New Collection
    For Each rgn In all_regions
        Regions.Add rgn, Format$(rgn.Number)
    Next rgn
End Function
' 4-color the map.
Private Function AssignColors4() As Boolean
Dim all_regions As New Collection
Dim rgn As MapRegion
Dim stack As New Collection

    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Make the regions copy their neighbor lists.
    For Each rgn In Regions
        rgn.SaveNeighbors
    Next rgn

    ' Save a copy of the region list.
    For Each rgn In Regions
        all_regions.Add rgn
    Next rgn

    ' Push regions onto the stack.
    Do While Regions.count > 0
        ' Look for a region with degree < 4.
        For Each rgn In Regions
            If rgn.Neighbors.count < 4 _
                Then Exit For
        Next rgn

        ' See if we found one.
        If rgn Is Nothing Then
            ' There are no more with degree < 4.
            Exit Do
        Else
            ' Push rgn onto the stack.
            stack.Add rgn

            ' Remove the node from the graph.
            rgn.RemoveFromGraph
            Regions.Remove Format$(rgn.Number)
        End If
    Loop
    Debug.Print "Map simplified from " & _
        all_regions.count & " to " & _
        Regions.count & " regions."

    ' Exhaustively color the rest of the map.
    AssignColors4 = ExhaustivelyColor(3)

    ' Pop regions off the stack and color them.
    Do While stack.count > 0
        ' Get the region.
        Set rgn = stack(stack.count)
        stack.Remove stack.count

        ' Restore the region to the map.
        Regions.Add rgn, Format$(rgn.Number)
        rgn.RestoreNeighbors

        ' Assign rgn a color different from
        ' those used by its neighbors.
        rgn.PickUnusedColor
    Loop

    ' Restore the region list to its original order.
    Set Regions = New Collection
    For Each rgn In all_regions
        Regions.Add rgn, Format$(rgn.Number)
    Next rgn
End Function


' 4-color the map.
Private Function AssignColors4Exhaustively() As Boolean
    ' Make the adjacency lists.
    FindNeighbors

    ' Reset the regions' colors.
    ResetColors

    ' Color the map.
    AssignColors4Exhaustively = ExhaustivelyColor(3)
End Function


' Color the map exhaustively.
' Return True if the map is not colorable with the
' given number of colors.
Public Function ExhaustivelyColor(ByVal MAX_COLOR As Integer) As Boolean
    ' If the map is empty, we don't need to color it.
    If Regions.count < 1 Then
        ExhaustivelyColor = False
        Exit Function
    End If

    ' See if there are a lot of region/color combinations.
    If Regions.count ^ (MAX_COLOR + 1) > 10000 Then
        If MsgBox("Warning: Exhaustively coloring " & _
                Regions.count & " regions with " & _
                MAX_COLOR + 1 & " colors may take a long time." & _
                vbCrLf & "Do you want to continue?", _
            vbYesNo Or vbQuestion, "Warning") = vbNo _
        Then
            ExhaustivelyColor = True
            Exit Function
        End If
    End If

    ' Make a traversal of the regions.
    Dim traversal As Collection
    Set traversal = MakeTraversal(Regions)

    ' Arbitrarily give the first region the first color.
    traversal(1).Color = 0

    ' Color the remaining regions exhaustively
    ' in traversal order.
    Dim count As Long
    ExhaustivelyColor = Not ExhaustivelyColorRegion(count, traversal, 2, MAX_COLOR)
    Debug.Print "Recursed " & count & " times."
End Function
' Make a collection that contains the regions
' in a pre-order traversal.
Private Function MakeTraversal(ByVal the_regions As Collection) As Collection
    ' Reset the regions' Traversed flags.
    Dim rgn As MapRegion
    For Each rgn In the_regions
        rgn.Traversed = False
    Next rgn

    ' Make a traversal of the regions.
    Dim traversal As New Collection
    For Each rgn In the_regions
        rgn.Traverse traversal
    Next rgn

    ' Return the traversal.
    Set MakeTraversal = traversal
End Function

' For each color, give this region the color and
' recursively assign colors to the remaining regions.
' Return True if we find a valid coloring.
Private Function ExhaustivelyColorRegion(ByRef count As Long, ByVal traversal As Collection, ByVal rgn_index As Integer, ByVal MAX_COLOR As Integer) As Boolean
    ' Assume we have a valid coloring.
    ExhaustivelyColorRegion = True

    count = count + 1
    ' If rgn_index > Regions.Count, then we
    ' have assigned colors to all regions so this
    ' is a valid coloring.
    If rgn_index > Regions.count Then Exit Function

    ' Try all the colors for this region.
    Dim rgn As MapRegion
    Set rgn = Regions(rgn_index)

    Dim clr As Integer
    For clr = 0 To MAX_COLOR
        ' See if a neighbor already has this color.
        If Not rgn.ColorUsedByNeighbors(clr) Then
            ' A neighbor isn't using this color.
            ' Try it.
            rgn.Color = clr

            ' Recursively color the rest of the regions.
            ' If this call returns True, then we
            ' have found a valid coloring so far.
            If ExhaustivelyColorRegion( _
                count, traversal, rgn_index + 1, MAX_COLOR) _
                    Then Exit Function
        End If
    Next clr
    rgn.Color = UNCOLORED

    ' We did not find a valid coloring.
    ExhaustivelyColorRegion = False
End Function
' Verify the map's coloring. Tell the user if this is
' an invalid coloring.
Public Sub VerifyColoring(ByVal max_allowed_color As Integer)
Dim rgn As MapRegion

    For Each rgn In Regions
        If Not rgn.VerifyColoring(max_allowed_color) Then
            ' Tell the user.
            MsgBox "This is NOT a valid coloring.", _
                vbOKOnly Or vbExclamation, _
                "Invalid Coloring"
            Exit For
        End If
    Next rgn
End Sub

' List each region's neighbors.
Private Sub ShowList()
Dim rgn As MapRegion

    FindNeighbors   ' Find the neighbors.
    
    For Each rgn In Regions
        rgn.ListNeighbors
    Next rgn
End Sub
' Find each regions neighbors.
Private Sub FindNeighbors()
Dim i1 As Integer
Dim i2 As Integer
Dim rgn1 As MapRegion
Dim rgn2 As MapRegion

    ' Do nothing if we already know the neighbors.
    If Not NeedNeighbors Then Exit Sub

    ' Clear out the neighbor collections.
    For Each rgn1 In Regions
        Set rgn1.Neighbors = New Collection
    Next rgn1

    ' Find the neighbors.
    For i1 = 1 To Regions.count - 1
        Set rgn1 = Regions(i1)
        For i2 = i1 + 1 To Regions.count
            rgn1.CheckNeighbor Regions(i2)
        Next i2
    Next i1

    NeedNeighbors = False
End Sub
' Redraw the map.
Private Sub Redraw()
Dim rgn As MapRegion

    MousePointer = vbHourglass
    DoEvents
    
    picMap.Cls
    
    ' Make the regions draw themselves.
    For Each rgn In Regions
        rgn.DrawRegion picMap
    Next rgn
    
    ' Display the region numbers if desired.
    If mnuDebugNumbers.Checked Then
        For Each rgn In Regions
            rgn.ShowNumber picMap
        Next rgn
    End If
    
    ' Display the neighbor count if desired.
    If mnuDebugCounts.Checked Then
        FindNeighbors
        For Each rgn In Regions
            rgn.ShowCount picMap
        Next rgn
    End If

    Set DrawingRegion = Nothing

    MousePointer = vbDefault
End Sub
' If there is an existing point within SNAP
' pixels in the X and Y directions, use its
' coordinates.
Private Sub SnapTo(X As Single, Y As Single)
Dim rgn As MapRegion

    For Each rgn In Regions
        rgn.SnapTo X, Y
    Next rgn
End Sub
' Save the map data.
Private Sub SaveMap(fname As String)
Dim fnum As Integer
Dim rgn As MapRegion

    fnum = FreeFile
    Open fname For Output As #fnum
    
    Write #fnum, Regions.count
    For Each rgn In Regions
        rgn.SaveData fnum
    Next rgn
    
    Close fnum
End Sub
' Load the map data.
Private Sub LoadMap(fname As String)
Dim fnum As Integer
Dim num_regions As Integer
Dim rgn As MapRegion
Dim i As Integer

    Set Regions = New Collection
    fnum = FreeFile
    Open fname For Input As #fnum
    
    Input #fnum, num_regions
    For i = 1 To num_regions
        Set rgn = New MapRegion
        rgn.Number = i
        Regions.Add rgn, Format$(rgn.Number)
        rgn.LoadData fnum
    Next i
    
    Close fnum
    NeedNeighbors = True
End Sub
' Initialize stuff.
Private Sub Form_Load()
    ' Initialize the colors.
    Colors(-1) = &H8000000F
    Colors(0) = vbRed
    Colors(1) = vbGreen
    Colors(2) = vbBlue
    Colors(3) = vbYellow
    Colors(4) = vbCyan

    ' Create an empty Regions collection.
    Set Regions = New Collection
End Sub

' Make the map as large as possible.
Private Sub Form_Resize()
    picMap.Move 0, 0, ScaleWidth, ScaleHeight
    Redraw
End Sub


' Start selecting a point for a region.
Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    SnapTo X, Y

    If (Button And vbRightButton) And _
        Not (DrawingRegion Is Nothing) _
    Then
        ' Finish the region we're drawing.
        picMap.DrawMode = vbInvert
        picMap.Line (LastX, LastY)-(CurX, CurY)
        picMap.DrawMode = vbCopyPen

        ' Connect back to the start.
        DrawingRegion.PtX.Add DrawingRegion.PtX(1)
        DrawingRegion.PtY.Add DrawingRegion.PtY(1)
        
        Set DrawingRegion = Nothing
        Redraw
        Exit Sub
    End If
    
    If DrawingRegion Is Nothing Then
        ' Start a new region.
        Set DrawingRegion = New MapRegion
        Regions.Add DrawingRegion, Format$(Regions.count + 1)
        DrawingRegion.Number = Regions.count
        NeedNeighbors = True
    Else
        ' Redraw the last line black.
        picMap.Line (LastX, LastY)-(CurX, CurY)
    End If
    
    DrawingRegion.PtX.Add X
    DrawingRegion.PtY.Add Y
    LastX = X
    LastY = Y
    CurX = X
    CurY = Y
    picMap.DrawMode = vbInvert
    picMap.Line (LastX, LastY)-(CurX, CurY)
    picMap.DrawMode = vbCopyPen
End Sub
' If we're drawing, draw a rubberband line.
Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If DrawingRegion Is Nothing Then Exit Sub
    
    picMap.DrawMode = vbInvert
    picMap.Line (LastX, LastY)-(CurX, CurY)
    SnapTo X, Y
    CurX = X
    CurY = Y
    picMap.Line (LastX, LastY)-(CurX, CurY)
    picMap.DrawMode = vbCopyPen
End Sub

' 5-color the map.
Private Sub mnuColor5_Click()
Dim rgn As MapRegion

    ClearMenuChecks
    mnuColor5.Checked = True
    MousePointer = vbHourglass
    DoEvents

    ' Assign the colors.
    AssignColors5

    ' Verify that this is a valid coloring.
    VerifyColoring 4

    Redraw
    MousePointer = vbDefault
End Sub

' Print the neighbor lists.
Private Sub mnuDebugLists_Click()
    ShowList
End Sub
' Exit.
Private Sub mnuFileExit_Click()
    Unload Me
End Sub
' Start a new map.
Private Sub mnuFileNew_Click()
    Set DrawingRegion = Nothing
    Set Regions = New Collection
    NeedNeighbors = True
    Redraw
End Sub

' Open an existing map file.
Private Sub mnuFileOpen_Click()
    On Error Resume Next
    FileDialog.ShowOpen
    If Err.Number <> 0 Then Exit Sub
    On Error GoTo 0
    
    LoadMap FileDialog.FileName

    ' Select not colored.
    mnuColor5.Checked = False
    
    Redraw
End Sub
' Save the current map.
Private Sub mnuFileSaveAs_Click()
    On Error Resume Next
    FileDialog.ShowSave
    If Err.Number <> 0 Then Exit Sub
    On Error GoTo 0

    Set DrawingRegion = Nothing
    SaveMap FileDialog.FileName
End Sub
